﻿using UnityEngine;
using UnityEngine.UI;

namespace eMPlus.Dome
{
    public class DomeDualProjectorMaster : MonoBehaviour
    {
        public GameObject canvas;
        GameObject[] projectors;
        RenderTexture[] renderTextures;
        GameObject[] monitors;

        // Use this for initialization
        void Start()
        {
            renderTextures = new RenderTexture[2];
            monitors = new GameObject[2];
            projectors = new GameObject[2];

            for (int n = 0; n < 2; n++)
            {
                renderTextures[n] = new RenderTexture(4096, 2160, 24);
                projectors[n] = transform.GetChild(n).gameObject;
                projectors[n].GetComponent<Camera>().targetTexture = renderTextures[n];

                monitors[n] = new GameObject("monitor " + (n + 1));
                var img = monitors[n].AddComponent<RawImage>();
                img.texture = renderTextures[n];
                monitors[n].transform.SetParent(canvas.transform);
                monitors[n].transform.localPosition = Vector3.zero;
                monitors[n].transform.localScale = new Vector3(1, 1, 1);
                RectTransform t = monitors[n].GetComponent<RectTransform>();
                if (n == 0)
                    t.SetInsetAndSizeFromParentEdge(RectTransform.Edge.Left, 1, 958);
                else
                    t.SetInsetAndSizeFromParentEdge(RectTransform.Edge.Right, 1, 958);
                t.SetInsetAndSizeFromParentEdge(RectTransform.Edge.Top, 1, 958f / 4096f * 2160f);

            }
        }

        // Update is called once per frame
        void Update()
        {
            if (Time.renderedFrameCount == 20)
            {
                for (int n = 1; n < 2; n++)
                {
                    projectors[n] = transform.GetChild(n).gameObject;
                    projectors[n].GetComponent<Dome2Projector>().originalCam.cullingMask = (1 << (30));
                    projectors[n].GetComponent<Dome2Projector>().sphereTransform.layer = 30;
                    projectors[n].GetComponent<Dome2Projector>().sphere.layer = 30;
                }
            }
        }
    }
}
