﻿using UnityEngine;
using UnityEngine.UI;

namespace eMPlus.Dome
{
    public class DomeProjectorSettings : MonoBehaviour
    {
        public GameObject stringPrefab;
        public GameObject floatPrefab;
        public GameObject projectorParent;

        GameObject[] ip;
        GameObject[] fov;
        GameObject[] shiftY;
        GameObject[] posX;
        GameObject[] posY;
        GameObject[] posZ;

        bool copied = false;

        // Use this for initialization
        void Start()
        {
            ip = new GameObject[2];
            fov = new GameObject[2];
            shiftY = new GameObject[2];
            posX = new GameObject[2];
            posY = new GameObject[2];
            posZ = new GameObject[2];

            for (int n = 0; n < 2; n++)
            {
                float y = 480;
                ip[n] = GameObject.Instantiate(stringPrefab, transform);
                ip[n].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Top, y += 30, 30);
                ip[n].transform.Find("Label").GetComponent<Text>().text = "IP";
                ip[n].transform.Find("Input").GetComponent<InputField>().text = "192.168.1.71";

                fov[n] = GameObject.Instantiate(floatPrefab, transform);
                fov[n].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Top, y += 30, 30);
                fov[n].transform.Find("Label").GetComponent<Text>().text = "FOV";

                shiftY[n] = GameObject.Instantiate(floatPrefab, transform);
                shiftY[n].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Top, y += 30, 30);
                shiftY[n].transform.Find("Label").GetComponent<Text>().text = "Shift Y";

                posX[n] = GameObject.Instantiate(floatPrefab, transform);
                posX[n].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Top, y += 30, 30);
                posX[n].transform.Find("Label").GetComponent<Text>().text = "Pos X";
                posX[n].GetComponent<SettingsFloatLine>().SetRange(-1.5f, 1.5f);

                posY[n] = GameObject.Instantiate(floatPrefab, transform);
                posY[n].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Top, y += 30, 30);
                posY[n].transform.Find("Label").GetComponent<Text>().text = "Pos Y";
                posY[n].GetComponent<SettingsFloatLine>().SetRange(-1.5f, 1.5f);

                posZ[n] = GameObject.Instantiate(floatPrefab, transform);
                posZ[n].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Top, y += 30, 30);
                posZ[n].transform.Find("Label").GetComponent<Text>().text = "Pos Z";
                posZ[n].GetComponent<SettingsFloatLine>().SetRange(-1.5f, 1.5f);
            }
            ip[1].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Left, 960, 960);
            fov[1].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Left, 960, 960);
            shiftY[1].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Left, 960, 960);
            posX[1].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Left, 960, 960);
            posY[1].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Left, 960, 960);
            posZ[1].GetComponent<RectTransform>().SetInsetAndSizeFromParentEdge(RectTransform.Edge.Left, 960, 960);
        }

        void valueChanged()
        {
            if (!copied) return;
            Debug.Log("Some value changed...");
            for (int n = 0; n < 2; n++)
            {
                var projector = projectorParent.transform.GetChild(n).GetComponent<Dome2Projector>();
                projector.projectorFov = fov[n].GetComponent<SettingsFloatLine>().floatValue;
                projector.projectorShiftY = shiftY[n].GetComponent<SettingsFloatLine>().floatValue;
                projector.sphereTransform.transform.position = new Vector3(posX[n].GetComponent<SettingsFloatLine>().floatValue, posY[n].GetComponent<SettingsFloatLine>().floatValue, posZ[n].GetComponent<SettingsFloatLine>().floatValue);
                projector.OnValidate();
            }
        }

        // Update is called once per frame
        void Update()
        {
            if (!copied && Time.renderedFrameCount > 10)
            {
                for (int n = 0; n < 2; n++)
                {
                    var projector = projectorParent.transform.GetChild(n).GetComponent<Dome2Projector>();
                    fov[n].transform.Find("Input").GetComponent<InputField>().text = projector.projectorFov.ToString();
                    fov[n].transform.Find("Slider").GetComponent<Slider>().value = projector.projectorFov;

                    shiftY[n].transform.Find("Input").GetComponent<InputField>().text = projector.projectorShiftY.ToString();
                    shiftY[n].transform.Find("Slider").GetComponent<Slider>().value = projector.projectorShiftY;
                }
                copied = true;
            }
        }
    }
}
