﻿using UnityEngine;
using UnityEngine.UI;

public class SettingsFloatLine : MonoBehaviour
{
    InputField input;
    Slider slider;
    public float floatValue;
    float minValue = -100;
    float maxValue = 100;
    bool needUpdateRange = false;

    public void SliderUpdate(float value) { floatValue = value;  input.text = value.ToString(); transform.parent.SendMessage("valueChanged"); }
    public void InputUpdate(string text) { floatValue = slider.value = System.Convert.ToSingle(text); transform.parent.SendMessage("valueChanged"); }

    // Use this for initialization
    void Start()
    {
        input = transform.Find("Input").gameObject.GetComponent<InputField>();
        slider = transform.Find("Slider").gameObject.GetComponent<Slider>();
        needUpdateRange = true;
    }

    public void SetRange(float min, float max)
    {
        minValue = min;
        maxValue = max;
        needUpdateRange = true;
    }

    // Update is called once per frame
    void Update()
    {
        if (needUpdateRange && slider)
        {
            needUpdateRange = false;
            slider.minValue = minValue;
            slider.maxValue = maxValue;
        }
    }
}
